///////////////////////////////////////////////////////////
// auPiECE.kpi
// muslib <--> kpi ԃC[
// by Yui N. / S. Kino.
//
// v1.00	2003.2.21		Yui N.		
// v1.01	2003.2.23		S. Kino.	σTvO[gΉ
//															iKb ̍ĐgvɓK킯ł͂Ȃj
// v1.02			V				Yui N,		[vȂȂŁCtIoł悤ɂ
//															i܂ȒvZ͎ĂȂj
// v1.03	2003.2.26		Yui N.		Kb ̍Đgvɉ悤ɂȂ
// v1.04	2003.3.07		Yui N.		ȒPȃtH[}bg`FbNs悤ɂ
// v1.05	2003.3.14		Yui N.		SOUNDINFO::dwUnitRender ̔{nsꂽ
//															ŉtI悤ɂi
// v1.06	2003.3.24		Yui N.		̂ Decoder ŃfR[hłȂoOގ
// v1.07	2003.5.03		Yui N.		Bu[gƃf`[Ȃdl
// v1.08  2003.8.03   Yui N., Kobarin
//															RpC Visual C++ .NET 2003 Ɉڍs
//															Kobarin ɂ re-entrant pb`荞
//															Kernel32.dll ɂˑ悤ɂ
// v1.09  2003.08.07  Yui N.		Bu[gƃGF[v̒Ȃ
// v1.10  2003.09.05  Yui N.		SOUNDINFO::dwUnitRender ̔{nɑΉ
//															V[Nx
///////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <math.h>

// muslib ̎dlɂĒ܂Ax render() oobt@TCY
#define RENDERSIZE (128 * sizeof(unsigned short))

#if 0	// VS.NET ƕsv *******************************************

//msvcrt.dll ȂĂ삷悤ɂ
//double gƕ_֌W̃JG[Ă܂̂ŁA
//_֌Wׂ͂ ASM 
//ȂƂȂĂ@̂ȂǁcB
//̂߂ɏĈ
//#if(n)def NOUSE_MSVCRT
//̕
//  Emus.c::SetEnvSpeed2
//  Emus.c::SetVibSpeed2
//  Ewinlayer.cpp::AuPIECEKPI::Open
//  Econtext.cpp  conv_num ̒l̃Rs[@
//
//ASM ͍̂߂ɂĂ킯ł͂Ȃł
//msvcrt.dll ɈˑȂ悤ɂƂĉς킯łȂǁi

#endif //***********************************************************

/* yui: VS.NET ƕsv**************************
//msvcrt.dll::malloc/free gȂ悤ɂ

	void *operator new(size_t Size)
	{
		return ::GlobalAlloc(GMEM_FIXED, Size);
	}
	void operator delete(void *p)
	{
		if(p){ ::GlobalFree(p); }
	}
**************************************************/

static BOOL kbPathRenameExtension(LPTSTR pszPath, LPCTSTR pszExt)
{//gqu
 //ėpIɎg킯ł͂Ȃ̂ŁAł
 //܂茵ȃ`FbN͂Ȃ
	char *p = pszPath;
	char *ext = NULL;

	while(*p)
	{
		if(IsDBCSLeadByte((BYTE)*p))
			p += 2;
		else
		{
			if(*p == '.')
				ext = p;
			else if(*p == '\\')
				ext = NULL;
			p++;
		}
	}
	if(ext)		
		lstrcpy(ext, pszExt);			//gq
	else
		lstrcat(pszPath, pszExt);		//gqȂ

	return TRUE;
}

extern "C"
{
#include "muslib/musdef.h"
#include "muslib/musdefwin.h"
#include "muslib/muslib.h"
#include "kmp_pi.h"
#include "context.h"

typedef enum
{
	emClosed, emOpened, emRunning
}DecoderStatus;

// NX`͍Ō
class AuPIECEKPI
{
private:
	unsigned char *m_pseq;			// V[PXf[^
	char *m_filename;						// t@C
	signed short *m_pbuffer;		//  Render() Ŏgobt@ւ̃|C^
	DecoderStatus m_status;
	void *m_pContext;
public:
	AuPIECEKPI();
	~AuPIECEKPI();
	BOOL  Open(const char *cszFileName, SOUNDINFO *pInfo);
	DWORD Render(BYTE* Buffer, DWORD dwSize);
	DWORD SetPosition(DWORD dwPos);
	void  Close();

	//CC֐ by Kobarin
	void	SetpBuffer(signed short *pNew){m_pbuffer = pNew;}
	signed short *GetpBuffer(){return m_pbuffer;}
	DecoderStatus GetStatus(){return m_status;}
	//܂

	void Start();
	void Stop();
};

// B̃CX^X
AuPIECEKPI *Decoder;
PCEWAVEINFO *pWave;

long FS, FS2, MCOUNT, FOFS;					// Yui: musdef.h ڂĂO[oϐ
static const int DEFAULT_FS = 44100;// Yui: ini ɂ Kb gw肪ȂƂ̃ftHg

HANDLE myhModule;
char INIfilename[1024];

// SK : muslib ̉ώgɔAeO[oϐ
extern long VOLS, ENVSTART, ENVSTOP, ENVRR;

extern unsigned char finish;	// mus.c

// P/ECE J[l API Gg|Cg
int pceWaveDataOut(int ch, PCEWAVEINFO *pwave)
{
	if(Decoder != NULL)
		Decoder->SetpBuffer((signed short *)pwave->pData);
	pWave = pwave;
	return 0;
}

// ȉCkpi Gg|Cg
static BOOL g_bInit;

void WINAPI kpiInit(void)
{
	if(!g_bInit)
	{
		GetModuleFileName((HMODULE)myhModule, INIfilename, 1024);
		kbPathRenameExtension(INIfilename, ".ini");
		piece_Context_Init();
		g_bInit = TRUE;
	}
}

void WINAPI kpiDeinit(void)
{
	if(g_bInit)
	{
		piece_Context_Deinit();
		g_bInit = FALSE;
	}
}

HKMP WINAPI kpiOpen(const char *cszFileName, SOUNDINFO *pInfo)
{
	if(pInfo == NULL)	return NULL;

	AuPIECEKPI *Decoder = new AuPIECEKPI;
	if(Decoder->Open(cszFileName, pInfo))
		return Decoder;

	delete Decoder;
	return NULL;
}

// Gg|Cgɂ͋LqĂȂ
HKMP WINAPI kpiOpenFromBuffer(const BYTE *Buffer, DWORD dwSize, SOUNDINFO *pInfo)
{
	return NULL;
}

void WINAPI kpiClose(HKMP hKMP)
{
	if(!hKMP)return;
	AuPIECEKPI *Decoder = (AuPIECEKPI*)hKMP;
	Decoder->Stop();
	Decoder->Close();
}

DWORD WINAPI kpiRender(HKMP hKMP, BYTE* Buffer, DWORD dwSize)
{
	if(!hKMP)return 0;
	AuPIECEKPI *Decoder = (AuPIECEKPI*)hKMP;
	return Decoder->Render(Buffer, dwSize);
}

DWORD WINAPI kpiSetPosition(HKMP hKMP, DWORD dwPos)
{
	if(!hKMP)return 0;
	AuPIECEKPI *Decoder = (AuPIECEKPI*)hKMP;
	return Decoder->SetPosition(dwPos);
}

// ȉNX`

AuPIECEKPI::AuPIECEKPI()
{
	m_pseq = NULL;
	m_filename = NULL;
	m_pbuffer = NULL;
	m_status = emClosed;
	m_pContext = piece_Context_Create(this);
}

AuPIECEKPI::~AuPIECEKPI()
{
	Close();
	piece_Context_Delete(m_pContext);
}

void AuPIECEKPI::Start()
{
	if(m_pseq == NULL)	return;
	piece_Context_Lock(m_pContext);
	InitMusic();													// yui: Ȃ̍Đ detune  vibrato ̏
	PlayMusic(m_pseq);
	m_status = emRunning;
	piece_Context_Unlock(m_pContext);
}

void AuPIECEKPI::Stop()
{
	piece_Context_Lock(m_pContext);
	StopMusic();
	piece_Context_Unlock(m_pContext);
	m_status = emOpened;
	m_pbuffer = NULL;
}

void AuPIECEKPI::Close()
{
	Stop();
	if(m_pseq != NULL)
	{
		delete [] m_pseq;
		m_pseq = NULL;
	}
	if(m_filename != NULL)
	{
		delete [] m_filename;
		m_filename = NULL;
	}
	m_status = emClosed;
}

BOOL AuPIECEKPI::Open(const char *cszFileName, SOUNDINFO *pInfo)
{
	HANDLE hFile;
	DWORD fsize, dwBytesRead;

	if(m_status != emClosed)
		return FALSE;

	piece_Context_Lock(m_pContext);
	// begin
		m_filename = new char[lstrlen(cszFileName) + 1];
		lstrcpy(m_filename, cszFileName);

		hFile = CreateFile(m_filename, GENERIC_READ, 0, NULL,
												OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if(hFile != INVALID_HANDLE_VALUE)
		{
			fsize = GetFileSize(hFile, NULL);

			m_pseq = new unsigned char[fsize + 1];
			ReadFile(hFile, m_pseq, fsize, &dwBytesRead, NULL);

			CloseHandle(hFile);
		}
		else
		{
			piece_Context_Unlock(m_pContext);
			return FALSE;
		}

		if(!GetPrivateProfileInt("auP/ECE", "DisableFormatCheck", 0, INIfilename))
		{
			// tH[}bg`FbN
			BYTE first, second;

			first = *m_pseq;	second = *(m_pseq + 1);
			if(first == 0x00)
			{
				if(second > 0x0f)
				{
					piece_Context_Unlock(m_pContext);
					return FALSE;
				}
			}
			else
				if(first > 0x0f)
				{
					piece_Context_Unlock(m_pContext);
					return FALSE;
				}
		}

		int defaultFS = GetPrivateProfileInt("auP/ECE", "SamplingFrequency", DEFAULT_FS, INIfilename);
		if(defaultFS <= 0)	defaultFS = DEFAULT_FS;

		// SK : muslib ̉ώgɔAeO[oϐ̏
			FS = pInfo->dwSamplesPerSec << 1;
			if(FS == 0)	FS = defaultFS << 1;

			FS2 = FS >> 1;
			//MCOUNT
			//(long)(FS2/128.0*2.5*16.0+0.5) == (long)((FS2*40)/128+0.5) == (long)(FS2*40.0+64.0)/128.0)
			//(FS2*40+64)/128
			MCOUNT = (FS2 * 40 + 64) >> 7;				// yui: gݍݎZ𗘗p

			//FOFS = (long)(auLog(FS2) / auLog(2.0) * 12.0 * 256.0 + 0.5)
			//     ==(long)(3072*auLog(FS2)/auLog(2.0)+1/2);
			FOFS = (long)(3072.0 * log((double)FS2) / log(2.0) + 0.5);

			VOLS = 1;

			// 2003.08.07 Yui N.
			// ENVSTART  ENVSTOP ̓[glł͂Ȃ̂ Freq. ɂ钲͕svI
			ENVSTART = ((-4 * 12 * 256) << VOLS);
			ENVSTOP = ((-10 * 12 * 256) << VOLS);
			
			// ENVRR ̖͂̂Ƃ背[glȂ̂ŒKv
			// Freq. オ瑝₷̂ł͂ȂČ炷
			// X / (fs2 / 16k) = (X / 1) / (fs2 / 16k) = 16k * x / fs2 * 1
			//ENVRR = (double)(4000 << VOLS) / ((double)FS2 / 16000.0);
			ENVRR = MulDiv(4000 << VOLS, 16000, FS2);
		// SK : ܂

		pInfo->dwSamplesPerSec = FS2;				//TvOg(44100, 22050 Ȃ)
		pInfo->dwChannels = 1;							//`l( mono = 1, stereo = 2)
		pInfo->dwBitsPerSample = 16;				//ʎqrbg( 8 or 16)
		pInfo->dwLength = 0xffffffff;				//Ȃ̒iSPC ̂悤ɌvZs\ȏꍇ 0xFFFFFFFFj
		pInfo->dwSeekable = 0;							//V[NT|[gĂꍇ 1AȂꍇ 0
		pInfo->dwUnitRender = RENDERSIZE * 32;					//Render ֐̑R͂̒l̔{niǂȒlłǂꍇ 0j
		pInfo->dwReserved1 = 1;							// 0
		pInfo->dwReserved2 = 0;							// 0

		m_pbuffer = NULL;
		m_status = emOpened;

		Start();
		
	// end.
	piece_Context_Unlock(m_pContext);
	return TRUE;
}

DWORD AuPIECEKPI::Render(BYTE* Buffer, DWORD dwSize)
{
	DWORD dwBytesToRender = dwSize, dwBytesRendered = 0;

	piece_Context_Lock(m_pContext);
		// yui: SOUNDINFO::dwUnitRender ̔{^ꂽƂɑΉ
		if(!finish)
		{
			do
			{
				if((Buffer != NULL) && (GetpBuffer() != NULL))
					CopyMemory(Buffer + dwBytesRendered, GetpBuffer(), RENDERSIZE);
				pWave->pfEndProc(pWave);
				dwBytesToRender -= RENDERSIZE;
				dwBytesRendered += RENDERSIZE;
			}while(dwBytesToRender > 0);
		}
	piece_Context_Unlock(m_pContext);

	return dwBytesRendered;
}

DWORD AuPIECEKPI::SetPosition(DWORD dwPos)
{
	Stop();
	Start();
	return 0;
}

}			// extern "C"

